
import java.awt.*;
import java.awt.event.*;
import java.awt.image.BufferedImage;
import java.awt.image.PixelGrabber;
import java.io.File;

import javax.imageio.ImageIO;
import javax.swing.*;


public class JFrame1 extends JFrame implements ActionListener {
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	public ImageIcon icon1;
	public ImageIcon icon2;
	public Image image1;
	public Image image2;
	public int[] px;
	public int[][] data;
	public int[][] dataX;
	public int[][] dataY;
	public int[] dataN;
	public int[] divData;
	public String[] df;
	public String text1 ="";
	public String text2 ="";
	public JPanel p1;
	public JPanel p2;
	public JPanel p3;
	
	public JLabel l1;
	public JLabel l2;
	public JLabel l3;
	public JButton b1;
	public JButton b2;
	public JButton b3;
	public JButton b4;
	public JTextArea ta1,ta2;

	public Graphics g;
	public int width1;
	public int height1;
	public int xs;
	public int ys;
	
	public int groupId = 0;
	public int testId = 0;
	public int imageId = -1;
	public int divCount;
	public final int GMAX = 100;
	public final int PMAX = 500;
	public final int IMAX = 20;
	public final int DMAX = 100;
	
	public static void main(String[] args){
		new JFrame1("基本図形の認識");
	}
	
	public JFrame1(String title)  {
		super(title);
		int lx=50;
		int ly=50;
		int ls=350;
		int bx=50;
		int by=250;
		int bw=200;
		int bh=50;
		int bs=60;
		int tax=350;
		int tay=250;
		int taw=300;
		int tah=300;
		
		setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);
		JPanel p1 = new JPanel();
		p1.setLayout(null);
		p1.setBackground(new Color(144,238,144));
		
		
		
		BufferedImage image1 = null;
		try {image1 = ImageIO.read(new File("new2.jpg"));}
		catch (Exception e) { e.printStackTrace(); image1 = null;}
		
		
		
		width1 = image1.getWidth(this);
		height1 = image1.getHeight(this);
		
		l1 = new JLabel(new ImageIcon(image1));
		l1.setBounds(lx, ly, width1, height1);
		p1.add(l1);
		
		px = new int[width1*height1];
		
		PixelGrabber pg = new PixelGrabber(image1 , 0 , 0 , width1, height1,px,0,width1);
		try { pg.grabPixels(); }
		catch (InterruptedException e) { }
		
		data = new int[width1][height1];
		
		BufferedImage image2 = new BufferedImage(width1,height1,BufferedImage.TYPE_4BYTE_ABGR);
		g = image2.createGraphics();
		
		g.setColor(Color.GREEN);
		g.fillRect(0,0,width1,height1);
		
		
		l2 = new JLabel(new ImageIcon(image2));
		
		l2.setBounds(lx+ls, ly, width1,height1);
		p1.add(l2);
		
		dataX = new int[GMAX][PMAX];
		dataY = new int[GMAX][PMAX];
		dataN = new int[GMAX];
		df = new String[PMAX];
		divData = new int[DMAX];
		
		
		
		b1 = new JButton("図形を選びます");
		b1.setHorizontalAlignment(JButton.LEFT);
		b1.setBounds(bx, by, bw, bh);
		p1.add(b1);
		b1.addActionListener(this);
		
		b2 = new JButton("図形の個数を調べます");
		b2.setHorizontalAlignment(JButton.LEFT);
		b2.setBounds(bx, by + bs, bw, bh);
		p1.add(b2);
		b2.addActionListener(this);
		
		
		b3 = new JButton("個々の図形を調べます");
		b3.setHorizontalAlignment(JButton.LEFT);
		b3.setBounds(bx, by + bs * 2, bw, bh);
		p1.add(b3);
		b3.addActionListener(this);
		
		b4 = new JButton("データを解析します");
		b4.setHorizontalAlignment(JButton.LEFT);
		b4.setBounds(bx, by + bs * 3, bw, bh);
		p1.add(b4);
		b4.addActionListener(this);

		
		l3 = new JLabel("図形を選んで下さい");
		l3.setBounds(tax, tay, bw,bh);
		l3.setForeground(Color.RED);		
		p1.add(l3);

		ta1 = new JTextArea("");
		JScrollPane sc1 = new JScrollPane();
		sc1.setViewportView(ta1);
		sc1.setBounds(tax,tay+bs, taw, tah);
		p1.add(sc1);	
		
		ta2 = new JTextArea("");
		JScrollPane sc2 = new JScrollPane();
		sc2.setViewportView(ta2);
		sc2.setBounds(tax+ls,tay+bs, taw, tah);
		p1.add(sc2);	
		
		getContentPane().add(p1, BorderLayout.CENTER);
		addWindowListener(new WindowClosing() );
	    setVisible(true);
	    setExtendedState(JFrame.MAXIMIZED_BOTH);
	}
	public void setPicture(int id){
		
	}
	
	public void setPixel(int x, int y, int pixel){
		try {
			
	        int red = pixel >> 16 & 255;
	        int green = pixel >> 8 & 255;
	        int blue = pixel & 255;
	       
			g.setColor(new Color(red,green,blue));
			g.drawRect(x, y, 1, 1);
		} catch (Exception e){
			l3.setText(e.toString());
		}
	}
	public int getPixel(int x, int y){
		int color = px[x + y * width1];
		return color;
	}
	public class WindowClosing extends WindowAdapter{
		public void windowClosing(WindowEvent e){
			int ans = JOptionPane.showConfirmDialog(JFrame1.this, "本当に終了しますか？");
	
			if (ans == JOptionPane.YES_OPTION){
				System.exit(0);  
			}
		}
	}
	
	public void actionPerformed(ActionEvent e) {
		if(e.getSource() == b1){
			groupId = 0;
			++imageId;
			if (imageId >3) imageId = 0;
			int imgNO = imageId+1;
			l3.setText("【"+imgNO + "番目のデータ】");
			String[] testImage = {"test1.jpg","test2.jpg","test3.jpg","test4.jpg"};
			BufferedImage image1 = null;
			try {image1 = ImageIO.read(new File(String.valueOf(testImage[imageId])));}
			catch (Exception e1) { e1.printStackTrace(); image1 = null;}
			
			width1 = image1.getWidth(this);
			height1 = image1.getHeight(this);
			
			px = new int[width1*height1];
			
			PixelGrabber pg = new PixelGrabber(image1 , 0 , 0 , width1, height1,px,0,width1);
			try { pg.grabPixels(); }
			catch (InterruptedException e2) { }
			
			data = new int[width1][height1];
			int x,y;
			for (y = 0; y < height1; y++){
				for (x = 0; x < width1; x++){
					int pixel = px[x + y * width1];
			        int red   = (pixel >> 16) & 0xff;
				    int green = (pixel >>  8) & 0xff;
				    int blue  = (pixel      ) & 0xff;
				    if (red >120 && green >120 && blue >120) {
				    	pixel = 0;
				    } else {
				    	pixel = -1;
				    }
				    data[x][y] = pixel; 
				}
			}
			
			l1.setIcon(new ImageIcon(image1));
			
			BufferedImage image2 = new BufferedImage(width1,height1,BufferedImage.TYPE_4BYTE_ABGR);
			g = image2.createGraphics();
			
			g.setColor(Color.GREEN);
			g.fillRect(0,0,width1,height1);
			
			
			l2.setIcon(new ImageIcon(image2));
		}
		if (e.getSource() == b2){
			if (imageId < 0) {
				l3.setText("図形を選んで下さい");
				return;
			}
			g.setColor(Color.RED);
			g.drawRect(0,0,width1-1,height1-1);
			l2.repaint();
			for (int y=1; y < height1-1; y++) {
				for (int x = 1; x < width1-1; x++) {
					if (data[x][y] <0) {
						xs = x;
						ys = y;
						++groupId;
						int ns = 0;
						recordPoint(groupId,ns,xs,ys);
						
						int sp = 1;
						while ( sp > 0){
							sp = searchPoint(groupId,xs,ys);
							movePoint(sp);
							++ns;
							recordPoint(groupId,ns,xs,ys);
						}
			
					}
				}
			}
			int[] color16 = {0,0xffffff,0x9acd32,0xb0e0e6,0xdc143c,0xff8c00,0xffff00,0x00bfff,
					0xee82ee,0xd3d3d3,0x8fbc8b,0x48d1cc,0xcfa8072,0xffdead,0x9932cc,0xffb6c1};
			
			for (int y=1; y < height1-2; y++) {
				for (int x = 1; x < width1-2; x++) {
					int px = data[x][y];
					if (px>=0) {
						int color = color16[data[x][y]];
						setPixel(x,y,color);
					}
				}
				
			}
			l2.repaint();
			l3.setText("図形は" + groupId+" 個あります");
		} else if(e.getSource() == b3){

			if (imageId < 0) {
				l3.setText("図形を選んで下さい");
				return;
			}
			text1="個々の図形のグループ化";
			int num;
			for (int i=1; i<=groupId;i++){
				num = dataN[i];
				text1 +="\n【" +i+"番目の図形】 　点列の長さ="+num+"　点の座標\n";
				for (int n = 0; n < num; n++){
					text1+="("+ dataX[i][n]+","+dataY[i][n]+")  ";
					if (n % 10 == 9) text1 += "\n";
				}
			}
			text1+="\n";
			ta1.setText(text1);
		} else if(e.getSource() == b4){
			if (imageId < 0) {
				l3.setText("図形を選んで下さい");
				return;
			}
			text2="個々の図形の解析";
			int num;
			for (int i=1; i<=groupId; i++){
				text2+="\n【" +i+"番目の図形】 ";
				num = dataN[i];				
				String str1="";
				for (int n = 0; n <num-3; n++){
					int dx=dataX[i][n+3]-dataX[i][n];
					int dy=dataY[i][n+3]-dataY[i][n];
					str1 = str1 + dVector(dx, dy);
				}
				
				text2 +="\nデータ解析（１６の方向ベクトルに分類）\n ベクトルの個数は"+str1.length()+"\n";
				text2 += str1;			
	
				text2 +="\nデータを平滑化します\n";
				String str2 = smoothingData(str1);
				text2 += str2;
		
				text2 += "\nデータを断片化します\n";
				String str3 =fragmentingData(str2);
				text2 = text2 + str3;
				
				text2 += "\nデータを直線化します\n";
				String str4 = linearizingData(str3);
				text2 += str4;
			
				text2 += "\nデータを再断片化します\n";
				String str5 =fragmentingData(str4);
				text2 += str5;
			}
			ta2.setText(text2);
		}
		
	}
	
	public void recordPoint(int id,int n, int x, int y) {
		dataX[id][n] = x;
		dataY[id][n] = y;
		data[x][y] = id;
		dataN[id]=n;
	}
	public int searchPoint(int id,int x, int y) {
		if (data[x+1][y]<0) {
			data[x+1][y]= id; return 1;
		} else if (data[x+1][y+1]<0){
			data[x+1][y+1]= id; return 2;
		} else if (data[x][y+1]<0){
			data[x][y+1]= id; return 3;
		} else if (data[x-1][y+1]<0){
			data[x-1][y+1]= id; return 4;
		} else if (data[x-1][y]<0){
			data[x-1][y]= id; return 5;
		} else if (data[x-1][y-1]<0){
			data[x-1][y-1]= id; return 6;
		} else if (data[x][y-1]<0){
			data[x][y-1]= id; return 7;
		} else if (data[x+1][y-1]<0){
			data[x+1][y-1]= id; return 8;
		} else if (data[x+1][y]>0) {
			return -1;
		} else if (data[x+1][y+1]<0){
			return -2;
		} else if (data[x][y+1]<0){
			return -3;
		} else if (data[x-1][y+1]<0){
			return -4;
		} else if (data[x-1][y]<0){
			return -5;
		} else if (data[x-1][y-1]<0){
			return -6;
		} else if (data[x][y-1]<0){
			return -7;
		} else if (data[x+1][y-1]<0){
			return -8;
		} else {
			return 0;
		}
	}
	public void movePoint(int sp) {
		switch (sp){
			case 1: ++xs; break;
			case 2: ++xs; ++ys; break;
			case 3: ++ys; break;
			case 4: --xs; ++ys; break;
			case 5: --xs; break;
			case 6: --xs; --ys; break;
			case 7: --ys; break;
			case 8: ++xs; --ys; break;
		}
	}
	public String dVector(int x,int y){
		String dir="";
		if (x > 0 && y == 0) dir = "0";
		if (x > 0 && y > 0 && x > y) dir = "1";
		if (x > 0 && y > 0 && x == y) dir = "2";
		if (x > 0 && y > 0 && x < y) dir = "3";
		if ( x == 0 && y > 0) dir = "4";
		if (x < 0 && y > 0 && -x < y) dir = "5";
		if (x < 0 && y > 0 && -x == y) dir = "6";
		if (x < 0 && y > 0 && -x > y) dir = "7";
		if (x < 0 && y == 0) dir = "8";
		if (x < 0 && y < 0 && x < y) dir = "9";
		if (x < 0 && y < 0 && x == y) dir = "a";
		if (x < 0 && y < 0 && x > y) dir = "b";
		if (x == 0 && y < 0) dir = "c";
		if (x > 0 && y < 0 && x < -y) dir = "d";
		if (x > 0 && y < 0 && x == -y) dir = "e";
		if (x > 0 && y < 0 && x > -y) dir = "f";
		return dir;
	}
	public String smoothingData(String str1){
		String str2 = "";
		String str3 = "";
		String c1 = "";
		String c2 = "";
		String c3 = "";
		int num = str1.length();
		for (int i=0 ; i < num-2; i++){
			try{
				str2 = str1.substring(0,i+1);
				str3 = str1.substring(i+2);
				c1 = str1.substring(i,i+1);
				int n1 = hexToDec(c1);
				c2 = str1.substring(i+1,i+2);
				int n2 = hexToDec(c2);
				c3 = str1.substring(i+2,i+3);
				int n3 = hexToDec(c3);
				if (n1 != n2){
					if (n1 == n3){
						c2 = c1;
					} else {
						if (Math.abs(n2 - n1) <= Math.abs(n3-n2)){
							c2 = c1;
						} else {
							c2 = c3;
						}
					}
					
				}
				str1 = str2 + c2 + str3;
				
			} catch (Exception e){
				ta1.setText(e.toString());
			}
		}
		return str1;
	}
	
	public int hexToDec(String str){
		int n=0;	
		try {
			n = Integer.parseInt(str,16);
		} catch(Exception e){
			ta1.setText(e.toString());
		}
		return n;
	}
	public String fragmentingData(String str1){
		
		String s0 = str1.substring(0,1);
		String str2 = s0;
		for(int i = 1; i < str1.length(); i++){
			String s1 = str1.substring(i,i+1);
			int n0 = hexToDec(s0);
			int n1 = hexToDec(s1);
			if (n0 != n1){
				str2 = str2 + s1;
				s0 = s1;
			}
		}
		return str2;
	}
	public String linearizingData(String str1){
		String str2 = "";
		String str3 = "";
		String c1 = "";
		String c2 = "";
		String c3 = "";
		int num = str1.length();
		for (int i= 0; i < num-2;i++){
			str2 = str1.substring(0,i+1);
			str3 = str1.substring(i+2);
			c1 = str1.substring(i,i+1);
			int n1 = hexToDec(c1);
			c2 = str1.substring(i+1,i+2);
			int n2 = hexToDec(c2);
			c3 = str1.substring(i+2,i+3);
			int n3 = hexToDec(c3);
			if (n1 == n3 && Math.abs(n2-n1) == 1){
				c2 = c1;
			}
			str1 = str2 + c2 + str3;
		}
		
		return str1;
	}
		

}
